// Created in 2017 by Ryan A. Colyer.
// This work is released with CC0 into the public domain.
// https://creativecommons.org/publicdomain/zero/1.0/
//
// https://www.thingiverse.com/thing:2392509


include <plot_function.scad>  // https://www.thingiverse.com/thing:2391851

two_slits = true;

// Plane wave
function Func4(x, y) = 2.5*(1+cos(y*36))+2;

// Double-slit interference
slit_pos = 10;
function Func5(x, y) = 1.25*(1+cos(sqrt(y*y+(x-slit_pos)*(x-slit_pos))*36)) +
  1.25*(1+cos(sqrt(y*y+(x+slit_pos)*(x+slit_pos))*36))+2;

// One-slit
function Func6(x, y) = 2.5*(1+cos(sqrt(y*y+(x-slit_pos)*(x-slit_pos))*36))+2;


module DoubleSlitInterference() {
  // Double-slit interference
  union() {
    PlotFunction(4, [-25, 0.4, 25], [-25, 0.4, 0]);
    difference() {
      translate([-25, -1, 0]) cube([50, 2, 16]);
      translate([slit_pos, 0, 16/2]) cube([2, 3, 16+2], center=true);
      translate([-slit_pos, 0, 16/2]) cube([2, 3, 16+2], center=true);
    }
    PlotFunction(5, [-25, 0.4, 25], [0, 0.4, 30]);
  }
}


module OneSlitWave() {
  // One-slit wave
  union() {
    PlotFunction(4, [-25, 0.4, 25], [-25, 0.4, 0]);
    difference() {
      translate([-25, -1, 0]) cube([50, 2, 16]);
      translate([slit_pos, 0, 16/2]) cube([2, 3, 16+2], center=true);
    }
    PlotFunction(6, [-25, 0.4, 25], [0, 0.4, 30]);
  }
}


rotate([0, 0, 180])
if (two_slits) {
  DoubleSlitInterference();
}
else {
  OneSlitWave();
}


